//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "SpielOberflaeche.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

TdieSpielOberflaeche *dieSpielOberflaeche;

#include "Spielsteuerung.h"
SpielSteuerung *dieSpielsteuerung;
int ANZ_MINEN = 5;

//---------------------------------------------------------------------------
__fastcall TdieSpielOberflaeche::TdieSpielOberflaeche(TComponent* Owner)
        : TForm(Owner)
{
  erzeugeSpiel();
}
//---------------------------------------------------------------------------
//-----  Ereignisroutinen  -------
//---------------------------------------------------------------------------
void __fastcall TdieSpielOberflaeche::StringGrid1MouseUp(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y)
{
  int col, row;
   StringGrid1->MouseToCell(X,Y,col,row);
   mausClickAufFeld(col, row);
}
//---------------------------------------------------------------------------
// statt gedruecktNeuesSpiel() : btnNeuesSpielClick()
void __fastcall TdieSpielOberflaeche::btnNeuesSpielClick(TObject *Sender)
{
   try
   {
   ANZ_MINEN = StrToInt(edtMulti->Text);
   }
   catch(...)
   {
   ANZ_MINEN = 5;
   }
   dieSpielsteuerung->starteNeuesSpiel(ANZ_MINEN);
}
//---------------------------------------------------------------------------
// statt gedruecktBeendeSpiel() : btnBeendeSpielClick()
void __fastcall TdieSpielOberflaeche::btnBeendeSpielClick(TObject *Sender)
{
   delete dieSpielsteuerung;
  Close();
}
//---------------------------------------------------------------------------
//-----  allgem. Operationen  -------
//---------------------------------------------------------------------------
void TdieSpielOberflaeche::erzeugeSpiel()
{
   dieSpielsteuerung = new SpielSteuerung(this);
   //dieSpielsteuerung->starteNeuesSpiel(ANZ_MINEN);
}
//---------------------------------------------------------------------------
void TdieSpielOberflaeche::mausClickAufFeld(int x, int y)
{
   dieSpielsteuerung->spieleZug(x, y);

  //StringGrid1->Cells[x][y] = " ";        // nur fr Testzwecke !!!
  //if (y == 4) zeigeMeldung(x);            // nur fr Testzwecke !!!
  //if (x==3 && y==4) loescheSpielbrett();  // nur fr Testzwecke !!!
}
//---------------------------------------------------------------------------
void TdieSpielOberflaeche::loescheSpielbrett()
{
  int x, y;
  for (x = 0; x <= 4; x++)
     for (y = 0; y <= 4; y++)
        StringGrid1->Cells[x][y]= " ";
}
//---------------------------------------------------------------------------
void TdieSpielOberflaeche::schreibeAufFeld(int x, int y, int z)
{
  if (z >= 0)
      StringGrid1->Cells [x][y] = IntToStr(z);
  else
      StringGrid1->Cells [x][y] = " ";   // Mine
}
//---------------------------------------------------------------------------
void TdieSpielOberflaeche::zeigeMeldung(int nr)
{
  switch(nr)
    {
    case 1: edtMulti->Text="Startzahl Minen";
            ShowMessage("*freu* Gewonnen!");
            break;
    case 2: ShowMessage("leider Verloren");
            edtMulti->Text="Startzahl Minen";
            break;
    case 3: edtMulti->Text="Das Spiel ist beendet";
            break;
    default://ShowMessage(" Anzahl der Minen: "+ IntToStr(nr) );
            edtMulti->Text=  " Anzahl der Minen: "+ IntToStr(nr);
            break;
    }
}
//---------------------------------------------------------------------------

void __fastcall TdieSpielOberflaeche::edtMultiClick(TObject *Sender)
{
edtMulti->Text="";
}
//---------------------------------------------------------------------------

