#include "SpielSteuerung.h"
#include "SpielDaten.h"
#include "SpielOberflaeche.h"

//##ModelId=47BD5D12035B
SpielSteuerung::SpielSteuerung(TdieSpielOberflaeche* dieGUI)
{
dieSpielDaten = new SpielDaten;
dieSpielOberflaeche = dieGUI;
}

//##ModelId=47BD5DA40000
SpielSteuerung::starteNeuesSpiel(int anzMinen)
{
if (anzMinen >=4 && anzMinen <= 25)
   {
   spielBeendet = false;
   dieSpielDaten->initialisiereSpielDaten(anzMinen);
   dieSpielOberflaeche->loescheSpielbrett();
   dieSpielOberflaeche->zeigeMeldung(dieSpielDaten->leseAnzahlMinen());
   }
}

//##ModelId=47BD5DD203A9
SpielSteuerung::spieleZug(int x, int y)
{
int mz, meldung, anzAufgedeckt;
if(!spielBeendet)
   {
   mz = analysiereSpielzug(x,y);
   if(mz!= -1)
      if(mz < 9)
         {
         dieSpielOberflaeche->schreibeAufFeld(x,y,mz);
         dieSpielDaten->schreibeFeldDaten(x,y,mz);
         anzAufgedeckt = dieSpielDaten->bestimmeAnzAufgedeckteFelder();
         if(25- dieSpielDaten->leseAnzahlMinen() == anzAufgedeckt)
            {
            meldung =1;
            spielBeendet = true;
            aufdeckenMinen();
            }
         else
            meldung = 0;
         }
      else
         meldung = 0;
   else
      {
      aufdeckenMinen();
      meldung = 2;
      spielBeendet = true;
      }
   }
else
   meldung = 3;
if (meldung != 0)
   dieSpielOberflaeche->zeigeMeldung(meldung);

}

//##ModelId=47BD5DF802EE
int SpielSteuerung::analysiereSpielzug(int x, int y)
{
int mz,xx,yy;
if(0 <= x && x<= 4 && 0<= y && y <= 4)
   {
   mz =0;
   if (dieSpielDaten->leseDatenfeld(x,y) != -1)
      {
      for(xx=x-1;xx<=x+1;xx++)
         for(yy=y-1;yy <= y+1;yy++)
             {
             if(0 <= xx && xx <= 4 && 0<= yy && yy <= 4)
                if (dieSpielDaten->leseDatenfeld(xx,yy) == -1)
                   mz++;
                else
                   ;
             else
                ;
             }
      return mz;
      }
   else
      return -1;
   }
else
   return 9;
}

//##ModelId=47BD5E3200FA
SpielSteuerung::aufdeckenMinen()
{
int x,y;
for (x = 0;x <= 4; x++)
   for (y = 0;y <= 4; y++)
      if(dieSpielDaten->leseDatenfeld(x,y) == -1)
         dieSpielOberflaeche->schreibeAufFeld(x,y,-1);
}

